
close all;

addpath("functions/")
addpath("functions_plotting/")
% addpath("cpp_code/")
addpath("cpp_code_smooth/")

publicationQuality();

dir_name = fullfile('figures','kde_pdfs');
status = mkdir(dir_name);

% class assignment
actual = distributions;
actual.generate_data = false;

% User Options ============================================================
% script switching board
estimator_call_flag =       true;   %<- true/false call SE on/off
estimator_plot_flag =       false;   %<- true/false plot SE results on/off
data_type_flag =            true;   %<- true/false integer powers of 2/real powers of 2
save_figs =                 true;   %<- true/false save .png of plots on/off
% rndom data generation parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
max_pow =                   17; %<---- maximum exponent to generate samples
min_pow =                   17; %<---- minimum exponent to generate samples
trials =                    1   ;  %<--- trials to run to generate heuristics for programs
step =                      4;  %<---- control synthetic rndom samples to skip being created
temp_min_limit =            0; %<---- set upper limit for both
actual.min_limit =          temp_min_limit;  %<--- lower limit to plot
temp_max_limit =            1000; %<---- set upper limit for both
actual.max_limit =          temp_max_limit; %<--- upper limit to plot
x_resolution =              1000;

% distribution_vector = ["Trimodal-Normal","Uniform","Normal","Uniform-Mix","Beta-a0p5-b1p5","Beta-a2-b0p5","Beta-a0p5-b0p5", "Generalized-Pareto", "Stable"];
% distribution = distribution_vector';
% names = ["Tri-Modal-Normal","Uniform", "Normal","Uniform-Mix", "Beta(0.5,1.5)", "Beta(2,0.5)", "Beta(0.5,0.5)", "Generalized-Pareto", "Stable"];

distribution_vector = ["Beta-a0p5-b0p5"];
distribution = distribution_vector';
names = ["Beta(0.5,0.5)"];


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Main Function Call Loop used to lable plot figures

% find amy of the strings in "str" inside of "distribtuionVector"
str = ["Beta-a0p5-b1p5","Beta-a2-b0p5","Beta-a0p5-b0p5"];
flag = zeros(1,length(distribution_vector));
for a = 1:size(distribution_vector,2)
    for b = 1:size(str,2)
        if strcmp(distribution_vector(a),str(b))
            flag(a) = 1;
            break
        else
            flag(a) = 0;
        end
    end
end

fail_nmem = zeros((max_pow-min_pow)/step, trials,length(distribution_vector));
fail_naps = zeros((max_pow-min_pow)/step, trials,length(distribution_vector));
lagrange_naps = zeros((max_pow-min_pow)/step, trials,length(distribution_vector));
lagrange_nmem = zeros((max_pow-min_pow)/step, trials,length(distribution_vector));

% change code to multithreaded version
for j = 1:length(distribution_vector)
    % Define plot vector for dist_list from 0-1
    if flag(j)
        actual.min_limit = 0;
        actual.max_limit = 1;
        actual.x = linspace(actual.min_limit,actual.max_limit,x_resolution); %<----******** need to update code
    else
        % Define plot vector for distribution from actual.min_limit-actual.max_limit
        actual.min_limit = 0;
        actual.max_limit = 10;
        actual.x = linspace(actual.min_limit,actual.max_limit,x_resolution);
    end
    % Current distribution name
    actual.dist_name = distribution_vector(j);
    % file name for actual distribution. "A_" puts at the top of the folder.
    actual.filename = sprintf(['A_', char(actual.dist_name),'_Act']);

    % creat rndom object
    rndom = actual;

    T_track = zeros(max_pow-min_pow,1);
    BR_track = zeros(max_pow-min_pow,trials);
    BR0_track = zeros(max_pow-min_pow,trials);
    sample_data = zeros(max_pow-min_pow,1);

    cpu_time_se = [];
    cpu_time_nmem = [];
    sample_track = [];

    % Create vector of  samples
    sample_vec = utils.sample_pow(min_pow,max_pow,data_type_flag,step);

    % create empty cells for plotting
    naps_pdfs = cell(length(distribution_vector), trials, length(sample_vec), 2);
    naps_cdfs = cell(length(distribution_vector), trials, length(sample_vec), 2);
    naps_sqrs = cell(length(distribution_vector), trials, length(sample_vec), 2);

    naps_kde_pdfs = cell(length(distribution_vector), trials, length(sample_vec), 2);
    naps_kde_cdfs = cell(length(distribution_vector), trials, length(sample_vec), 2);
    naps_kde_sqrs = cell(length(distribution_vector), trials, length(sample_vec), 2);

    kde_pdfs = cell(length(distribution_vector), trials, length(sample_vec), 2);
    kde_cdfs = cell(length(distribution_vector), trials, length(sample_vec), 2);
    kde_sqrs = cell(length(distribution_vector), trials, length(sample_vec), 2);

    nmem_pdfs = cell(length(distribution_vector), trials, length(sample_vec), 2);
    nmem_cdfs = cell(length(distribution_vector), trials, length(sample_vec), 2);
    nmem_sqrs = cell(length(distribution_vector), trials, length(sample_vec), 2);

    cpu_vec_se = zeros(length(sample_vec),trials);
    cpu_vec_nmem = zeros(length(sample_vec),trials);
    kl_vec_se = zeros(length(sample_vec),trials);
    kl_vec_nmem = zeros(length(sample_vec),trials);
    mse_vec_se = zeros(length(sample_vec),trials);
    mse_vec_nmem = zeros(length(sample_vec),trials);

    for i = 1:trials

        actual = actual.dist_list();

        for k = 1:length(sample_vec)

            tic
            % initialize to 0. used to count number of failed NMEM pdfe
            fail_flag = 0;

            rndom.Ns = sample_vec(k);
            realx = linspace(actual.min_limit,actual.max_limit,rndom.Ns);

            % Create rndom.filename for each distribtuion
            rndom.filename = sprintf(['D_', char(actual.dist_name),'_T_','%d', '_S_','%d'],i, rndom.Ns);

            %-- NAP w/ KDE
            rndom.randomVSactual = "random";
            rndom = dist_list(rndom);
            sample = rndom.rndData;

            tintialSE = cputime;

            % naps object instantiation
            naps_kde = NAPSkde;
            serial = true;
            naps_kde = naps_kde.stitch(sample, serial);

            % extract relevant parameters from object after stich() method
            fail_code = naps_kde.failed;
            x_naps_kde = naps_kde.sx;
            SE_pdf_kde = naps_kde.sPDF;
            rndom.Ns = naps_kde.N;
            binrndom.Ns =  naps_kde.binN;


            %-- NAP w/o KDE
            rndom.randomVSactual = "random";
            rndom = dist_list(rndom);
            sample = rndom.rndData;

            tintialSE = cputime;

            % naps object instantiation
            naps = NAPS;
            serial = true;
            naps = naps.stitch(sample, serial);

            % extract relevant parameters from object after stich() method
            fail_code = naps.failed;
            x_naps = naps.sx;
            SE_pdf = naps.sPDF;
            SE_cdf = naps.sCDF;
            SE_u = naps.u;
            SE_SQR = naps.sqr;
            nBlocks = naps.nBlocks;
            rndom.Ns = naps.N;
            binrndom.Ns =  naps.binN;
            max_LG = naps.LG_max;
            sum_LG = naps.LG_sum;
            T = naps.T;
            BRlevel = naps.BRlevel;
            BR0 = naps.BR0;

            tcpuSE = cputime-tintialSE;

            disp(['Number of blocks: ', num2str(nBlocks)])

            %-- KDE
            tintialNMEM = cputime;
            [pdf_KDE,x_KDE] = ksdensity(sample);
            tcpuNMEM = cputime-tintialNMEM;

            %-- NMEM
            try
                tintialNMEM = cputime;
                [failed, x_NMEM, pdf_NMEM, cdf_NMEM,sqr_NMEM, ~,lagrange_multipler] = EstimatePDF(sample);
                fail_nmem(k,i,j) = 0;
                tcpuNMEM = cputime-tintialNMEM;

                n = length(sqr_NMEM);
                dx = 1 / (n + 1);
                u_NMEM = dx:dx:(n * dx);
            catch
                warning('Problem using function.  Assigning a value of 0.');
                lagrange_multipler = 0;
                x_NMEM = linspace(min(sample),max(sample),length(sample))';
                pdf_NMEM = 0*ones(length(sample),1);
                cdf_NMEM = 0*ones(length(sample),1);
                fail_nmem(k,i,j) = 1;
                % don't record cpu time if estimator failed
                tcpuNMEM = NaN;
            end

            nmem_pdfs{j,i,k,1} = x_NMEM;
            nmem_pdfs{j,i,k,2} = pdf_NMEM;

            naps_pdfs{j,i,k,1} = x_naps;
            naps_pdfs{j,i,k,2} = SE_pdf;

            naps_kde_pdfs{j,i,k,1} = x_naps_kde;
            naps_kde_pdfs{j,i,k,2} = SE_pdf_kde;

            kde_pdfs{j,i,k,1} = x_KDE;
            kde_pdfs{j,i,k,2} = pdf_KDE;

            toc
            disp([char(actual.dist_name),...
                ', Trial: ',num2str(i),'/', num2str(trials), ...
                ' sample size: ',num2str(sample_vec(k))])
        end
    end

    % PDFs ----------------------------------------------------------------
    xl1 = [-0.1, 1.1];
    yl1 = [-0.1, 0.8];
    xl2 = [0, 10];
    yl2 = [-0.1, 6];

    for k = 1:length(sample_vec)

        % subplots --------------------------------------------------------
        fig_name = sprintf('pdf_d_%s_%s', convertCharsToStrings(distribution_vector(j)), num2str(sample_vec(k)));
        f = figure('Name',fig_name);

        subplot(2,2,3)
        hold on;
        for i = 1:trials
            plot(actual.x, actual.pdf_y, '--k')
            p1 = plot(naps_kde_pdfs{j,i,k,1}, naps_kde_pdfs{j,i,k,2}, '-m', DisplayName='$NAPS(KDE)$');

            if max(actual.x) > 3
                xlim(xl2)
            else
                xlim(xl1)
            end
            if max(actual.pdf_y) > 1
                ylim(yl2)
            else
                ylim(yl1)
            end
        end
        xlabel('$x$', 'interpreter','latex')
        ylabel('$\hat{f}(x)$', 'interpreter','latex')
        legend([p1],'Location','north','interpreter','latex')
        subplot(2,2,1)
        hold on;
        for i = 1:trials
            plot(actual.x, actual.pdf_y, '--k')
            p2 = plot(kde_pdfs{j,i,k,1}, kde_pdfs{j,i,k,2}, '-g', DisplayName='$KDE$');

            if max(actual.x) > 3
                xlim(xl2)
            else
                xlim(xl1)
            end
            if max(actual.pdf_y) > 1
                ylim(yl2)
            else
                ylim(yl1)
            end

        end
        ylabel('$\hat{f}(x)$', 'interpreter','latex')
        legend([p2],'Location','north','interpreter','latex')
        subplot(2,2,4)
        hold on;
        for i = 1:trials
            plot(actual.x, actual.pdf_y, '--k')
            p3 = plot(naps_pdfs{j,i,k,1}, naps_pdfs{j,i,k,2}, '-r', DisplayName='$NAPS$');

            if max(actual.x) > 3
                xlim(xl2)
            else
                xlim(xl1)
            end
            if max(actual.pdf_y) > 1
                ylim(yl2)
            else
                ylim(yl1)
            end

        end
        xlabel('$x$', 'interpreter','latex')
        legend([p3],'Location','north','interpreter','latex')
        subplot(2,2,2)
        hold on;
        for i = 1:trials
            plot(actual.x, actual.pdf_y, '--k')
            p4 = plot(nmem_pdfs{j,i,k,1}, nmem_pdfs{j,i,k,2}, '-b', DisplayName='$NMEM$');

            if max(actual.x) > 3
                xlim(xl2)
            else
                xlim(xl1)
            end
            if max(actual.pdf_y) > 1
                ylim(yl2)
            else
                ylim(yl1)
            end

        end
        xlabel('$x$', 'interpreter','latex')
        legend([p4],'Location','north','interpreter','latex')
        bp = gca;
        if save_figs
            fig_export(f ,fullfile(dir_name, fig_name),'naps')
        end

        % individual figures ----------------------------------------------
        fig_name = sprintf('pdf_d_%s_%s', convertCharsToStrings(distribution_vector(j)), num2str(sample_vec(k)));
        fig_name_mod = ['NAP_KDE_',fig_name];

        f = figure('Name',fig_name_mod);
        hold on;
        for i = 1:trials
            plot(actual.x, actual.pdf_y, '--k')
            p = plot(naps_kde_pdfs{j,i,k,1}, naps_kde_pdfs{j,i,k,2}, '-', 'color', "#7E2F8E", DisplayName='$NAPS(KDE)$');

            if max(actual.x) > 3
                xlim(xl2)
            else
                xlim(xl1)
            end
            if max(actual.pdf_y) > 1
                ylim(yl2)
            else
                ylim(yl1)
            end

        end
        xlabel('$x$', 'interpreter','latex')
        ylabel('$\hat{f}(x)$','interpreter','latex')
        legend([p],'Location','north','interpreter','latex')
        bp = gca;
        if save_figs
            fig_export(f ,fullfile(dir_name, fig_name_mod),'naps')
        end

        fig_name_mod = ['KDE_',fig_name];

        f = figure('Name',fig_name_mod);
        hold on;
        for i = 1:trials
            plot(actual.x, actual.pdf_y, '--k')
            p = plot(kde_pdfs{j,i,k,1}, kde_pdfs{j,i,k,2}, '-g', DisplayName='$KDE$');

            if max(actual.x) > 3
                xlim(xl2)
            else
                xlim(xl1)
            end
            if max(actual.pdf_y) > 1
                ylim(yl2)
            else
                ylim(yl1)
            end
        end
        xlabel('$x$', 'interpreter','latex')
        ylabel('$\hat{f}(x)$', 'interpreter','latex')
        legend([p],'Location','north','interpreter','latex')
        bp = gca;
        if save_figs
            fig_export(f ,fullfile(dir_name, fig_name_mod),'naps')
        end

        fig_name_mod = ['NAP_',fig_name];

        f = figure('Name',fig_name_mod);
        hold on;
        for i = 1:trials
            plot(actual.x, actual.pdf_y, '--k')
            p = plot(naps_pdfs{j,i,k,1}, naps_pdfs{j,i,k,2}, '-r', DisplayName='$NAPS(NMEM)$');

            if max(actual.x) > 3
                xlim(xl2)
            else
                xlim(xl1)
            end
            if max(actual.pdf_y) > 1
                ylim(yl2)
            else
                ylim(yl1)
            end

        end
        xlabel('$x$', 'interpreter','latex')
        ylabel('$\hat{f}(x)$', 'interpreter','latex')
        legend([p],'Location','north','interpreter','latex')
        bp = gca;
        if save_figs
            fig_export(f ,fullfile(dir_name, fig_name_mod),'naps')
        end


        fig_name_mod = ['NMEM_',fig_name];

        f = figure('Name',fig_name_mod);
        hold on;
        for i = 1:trials
            plot(actual.x, actual.pdf_y, '--k')
            p = plot(nmem_pdfs{j,i,k,1}, nmem_pdfs{j,i,k,2}, '-b', DisplayName='$NMEM$');

            if max(actual.x) > 3
                xlim(xl2)
            else
                xlim(xl1)
            end
            if max(actual.pdf_y) > 1
                ylim(yl2)
            else
                ylim(yl1)
            end

        end
        ylabel('$\hat{f}(x)$', 'interpreter','latex')
        legend([p],'Location','north','interpreter','latex')
        bp = gca;
        if save_figs
            fig_export(f ,fullfile(dir_name, fig_name_mod),'naps')
        end
    end

end






